import { VNode, VNodeChildren } from 'vue';
import { ValidationMessages, ValidationTranslator } from '../type';
export declare type ComponentFormMethods<T = Record<string, any>> = {
    [key: string]: any;
    submit: () => Promise<void>;
};
export declare type ComponentFormComputed<T = Record<string, any>> = {
    isEditing: boolean;
};
export declare type ComponentFormData<T = Record<string, any>> = {
    busy: boolean;
    form: Partial<T> | null;
};
export declare type ComponentFormVuelidate<T = Record<string, any>> = {
    $v: {
        [key: string]: any;
        form: {
            [K in keyof T]: any;
        };
    };
};
export declare type FormGroupProps = {
    errors: string[];
    invalid: boolean;
};
export declare type FormInputBuildContext<T extends Record<string, any> = Record<string, any>> = {
    title: string | VNode | (VNode | string)[];
    propName: keyof T | string;
    attrs?: Record<string, any>;
    domProps?: Record<string, any>;
    changeCallback?: (input: string) => void;
    validationMessages?: ValidationMessages;
    validationTranslator?: ValidationTranslator;
};
export declare type FormSelectOption = {
    id: string | number;
    value: any;
};
export declare type FormSelectBuildContext<T extends Record<string, any> = Record<string, any>> = {
    title: VNodeChildren;
    propName: keyof T | string;
    attrs?: Record<string, any>;
    domProps?: Record<string, any>;
    changeCallback?: (input: any) => void;
    options: FormSelectOption[];
    optionDefaultText?: string;
    validationMessages?: ValidationMessages;
    validationTranslator?: ValidationTranslator;
};
export declare type FormSubmitOptions = {
    updateText?: string;
    updateIcon?: string;
    createText?: string;
    createIcon?: string;
};
export declare type FormTextareaBuildContext<T extends Record<string, any> = Record<string, any>> = {
    title: string | VNode | (VNode | string)[];
    propName: keyof T | string;
    attrs?: Record<string, any>;
    validationMessages?: ValidationMessages;
    validationTranslator?: ValidationTranslator;
};
//# sourceMappingURL=type.d.ts.map